unit fMain;

{$mode objfpc}{$H+}

interface

uses
  Classes,
  SysUtils,
  SQLite3Conn,
  SQLDB,
  DB,
  Forms,
  Controls,
  Graphics,
  Dialogs,
  StdCtrls,
  DBGrids, DBCtrls;

type

  { TfrmMain }

  TfrmMain = class(TForm)
    btnDatenHolen: TButton;
    DataSource: TDataSource;
    dbgDaten: TDBGrid;
    DBNavigator1: TDBNavigator;
    SQLite3Connection: TSQLite3Connection;
    SQLQuery: TSQLQuery;
    SQLTransaction: TSQLTransaction;
    procedure btnDatenHolenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SQLite3ConnectionAfterConnect(Sender: TObject);
    procedure SQLQueryCalcFields(DataSet: TDataSet);
  private

  public

  end;

var
  frmMain: TfrmMain;

implementation

{$R *.lfm}

{ TfrmMain }

procedure TfrmMain.btnDatenHolenClick(Sender: TObject);
var
  MyFields: array of TField;
  Temf: TStringField;
  i: integer;
begin
  SQLQuery.SQL.Text := 'SELECT id, name, substr(name, 1, 2) AS test FROM Test';
  SQLQuery.Open;
  SQLQuery.Close;

  SetLength(MyFields, SQLQuery.FieldDefs.Count);
  for i := 0 to SQLQuery.FieldDefs.Count - 1 do
    MyFields[i] := SQLQuery.FieldDefs[i].CreateField(SQLQuery);
  Temf := TStringField.Create(nil);
  Temf.FieldKind := fkCalculated;
  Temf.FieldName := 'NewCalcField';
  Temf.DataSet := SQLQuery;
  SQLQuery.Open;

  SQLQuery.First;

  while not SQLQuery.EOF do
  begin
    //Temf.Value:='Test';
    //dbgDaten.DataSource.DataSet.FieldByName('NewCalcField').Value := 'Test';

    SQLQuery.Next;
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  SQLite3Connection.Transaction := SQLTransaction;
  SQLTransaction.Active := True;
  SQLite3Connection.Connected := True;
end;

procedure TfrmMain.SQLite3ConnectionAfterConnect(Sender: TObject);
begin

end;

procedure TfrmMain.SQLQueryCalcFields(DataSet: TDataSet);
begin
  DataSet.FieldByName('NewCalcField').Value := 'test';
end;

end.
